// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from qb_softhand_industry_msgs:msg/StateStamped.idl
// generated code does not contain a copyright notice

#ifndef QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__STATE_STAMPED__STRUCT_HPP_
#define QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__STATE_STAMPED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'device_data'
#include "qb_softhand_industry_msgs/msg/detail/state__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__qb_softhand_industry_msgs__msg__StateStamped __attribute__((deprecated))
#else
# define DEPRECATED__qb_softhand_industry_msgs__msg__StateStamped __declspec(deprecated)
#endif

namespace qb_softhand_industry_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct StateStamped_
{
  using Type = StateStamped_<ContainerAllocator>;

  explicit StateStamped_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    device_data(_init)
  {
    (void)_init;
  }

  explicit StateStamped_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    device_data(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _device_data_type =
    qb_softhand_industry_msgs::msg::State_<ContainerAllocator>;
  _device_data_type device_data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__device_data(
    const qb_softhand_industry_msgs::msg::State_<ContainerAllocator> & _arg)
  {
    this->device_data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator> *;
  using ConstRawPtr =
    const qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__qb_softhand_industry_msgs__msg__StateStamped
    std::shared_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__qb_softhand_industry_msgs__msg__StateStamped
    std::shared_ptr<qb_softhand_industry_msgs::msg::StateStamped_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StateStamped_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->device_data != other.device_data) {
      return false;
    }
    return true;
  }
  bool operator!=(const StateStamped_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StateStamped_

// alias to use template instance with default allocator
using StateStamped =
  qb_softhand_industry_msgs::msg::StateStamped_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace qb_softhand_industry_msgs

#endif  // QB_SOFTHAND_INDUSTRY_MSGS__MSG__DETAIL__STATE_STAMPED__STRUCT_HPP_
